function [bp,rp,Vmin,Vmax]=calculate_partitions(varargin)
% generates the partition and the associated set of 
% quantities 
global lpm_child 
lpm_child = varargin{1};
schr = get(lpm_child,'schrod');
x_min = get(schr,'min');
x_max = get(schr,'max');
tol = get(lpm_child,'tol');

%calculate partition:
% this furnishes the vector of stepsizes (bp.h) and the elements of the one
% step propagator (matrices bp.cu, bp.cup, bp.cv, bp.cvp) + bp.Vbar
% and bp.imatch (the interval at the rhs of which is the matching point)
rp=[];
x = x_min;
i=0;
trial_h = (x_max-x_min)/10;
while x < x_max
    i=i+1;
    [h,bp.V0(i),bp.V(:,i)] = get_step(x,trial_h,x_max-x,tol);
    [V01,V1] = calculate_V(x,h/2);
    [V02,V2] = calculate_V(x+h/2,h/2);
    [bp.cu(:,:,i),bp.cup(:,:,i),bp.cv(:,:,i),bp.cvp(:,:,i)] = get_coeff(lpm_child,bp.V(:,i),h);
    k=2*i-1;
    rp.h(k) = h/2;
    rp.V0(k)= V01;
    rp.V(:,k)= V1;
    [rp.cu(:,:,k),rp.cup(:,:,k),rp.cv(:,:,k),rp.cvp(:,:,k)] = get_coeff(lpm_child,rp.V(:,k),h/2); 
    k=2*i;
    rp.h(k) = h/2;
    rp.V0(k)= V02;
    rp.V(:,k)= V2;
    [rp.cu(:,:,k),rp.cup(:,:,k),rp.cv(:,:,k),rp.cvp(:,:,k)] = get_coeff(lpm_child,rp.V(:,k),h/2);
    x = x + h;
    trial_h=h*2;
    bp.h(i)=h;
end

%rp: reference partition (used to form an estimation of the error in the
%calculated eigenvalues)
[Vmin,bp.imatch] = min(bp.V0);
if bp.imatch == length(bp.h)
    bp.imatch=length(bp.h)-1;
end
rp.imatch=bp.imatch*2;
Vmax = max(bp.V0);


