function p = lpm(varargin)
%LPM class constructor
% p = lpm(schrod/slp,tol)
%
% schrod/slp    - Schrod_object or slp-object
% tol           - positive DP constant representing the accuracy requested
%
% LPM is a parent class. The user should use the derived classes (lpm10)

switch nargin
case 0
    % if no input arguments, create a default object
   p.schrod = schrod;
   p.tol = 10^(-8);
   p= class(sch,'lpm');
case 1  
    %copy-constructor
 if isa(varargin{1},'lpm')
     p  = varargin{1};
 else
     disp('Input argument is not a lpm-object')
 end
case 2
    if ~isa(varargin{1},'schrod') 
         disp 'arg1: You need to pass a schrodinger-object';  
         return;
    elseif ~isa(varargin{2}, 'double')  
      disp 'arg2: You need to pass a double-precision floating-point number';  
      return;
    end
    p.schrod = varargin{1};
    p.tol = varargin{2};
    p = class(p,'lpm');
otherwise
    error('Wrong number of input arguments')
end;