function E=calculate_eigenvalues(emin,emax,nmin,nmax)
%CALCULATE_EIGENVALUES
%[eigvbasic,index,err,status]=calculate_eigenvalues(lpm_child,emin,emax,nmin,nmax)
% search of the eigenvalues with index n from nmin to nmax 

global lpm_child
bp = get(lpm_child,'bp');
rp = get(lpm_child,'rp');
Vmin = get(lpm_child,'Vmin');
Vmax = get(lpm_child,'Vmax');
tol = get(lpm_child,'tol');
truncated = false;

e_low = emin;
n_low = nmin;
len=length(bp.h);
phi_low=locate_eigenvalue(e_low,bp,Vmin);
number_eigv = 0; 
h_en = (emax-emin)/(5*(nmax-nmin+1));
h_mem = h_en;

for n=nmin:nmax  
	number_eigv = number_eigv + 1;
    % an energy interval [e_low,e_up] is searched such that any e in
    % this interval represents a good initial guess. (there is only one
    % eigenvalue in this interval).
    h_en = abs(min(h_mem,h_en));
    phi_low0=phi_low;
    while true
      %h_en = abs(min(h_mem,h_en))  
	  e_up = e_low + h_en;
      [n_up,phi_up] = locate_eigenvalue(e_up,bp,Vmin);
      if h_en > 0 && n_up < n_low
          % something wrong
          e_up1 = e_low + 2*h_en;
          [n_up1,phi_up1] = locate_eigenvalue(e_up1,bp,Vmin);
          e_up2 = e_low + 3*h_en;
          [n_up2,phi_up2] = locate_eigenvalue(e_up2,bp,Vmin);
          if n_up2<n_up1
              n_up=n_up2;
              phi_up=phi_up2;
              e_up=e_up2;
          else
              n_up=n_up1;
              phi_up=phi_up1;
              e_up=e_up1;
          end
      end
      rz2 = n_up-n-1;
	  if rz2>1 %|| phi_up*phi_low<0 
          h_en=h_en/2;
      elseif rz2 < 0 
	     e_low = e_up;
         phi_low = phi_up;
         n_low = n_up;
         h_en = h_en*2;
%       elseif phi_low*phi_up>0 && phi_low0*phi_up>0
%          e_low = e_up;
%          phi_low = phi_up;
%          n_low = n_up;
%          h_en = h_en*2;
      else
         e_upt = e_up + h_en/2;
         [n_upt,phi_upt] = locate_eigenvalue(e_upt,bp,Vmin);
         if n_upt-n-1 > 0
             break; % stop while	
         else
             h_en=1.2*h_en;
         end
      end
	 end %while
     % calculate the eigenvalue corresponding to the reference
     % partition:
      [ev,evpruf0] = calculate_eigenvalue(e_low,e_up,phi_up,rp,Vmin);
    
     % compute basic eigenvalue: the reference one is used as
     % initial guess
      [evx,evpruf]= calculate_eigenvalue(ev,bp,Vmin);
      eigv(number_eigv) = evx;
      index(number_eigv) = round(evpruf - 1);
      indexr(number_eigv) = round(evpruf0 - 1);	
	  err(number_eigv) = (evx-ev)*1.005;%*1.05;
      h_en = min(e_up-e_low,h_en);
	  e_low = max(e_up,min(ev,evx));
      phi_low=locate_eigenvalue(e_low,bp,Vmin);
	  n_low = n_up;
end %for


for i=1:number_eigv
	if indexr(i) == -1
        status(i)=1;
        continue;
    elseif indexr(i) ~= index(i)
        status(i)=2;
    elseif index(i)~= nmin+i-1
        status(i)=3;
    else
        status(i)=0;
        continue;
    end
    if status(i) == 2 && index(i) ~= nmin+i-1 
        status(i) = 4;
    end
end %for

E.eigenvalues=eigv;
E.indices=index;
E.errors=err;
E.status=status;


