function [varargout]=get_initConditions(varargin)
% @PPM\GET_INITCONDITIONS
% [yi,yf]=get_initConditions
% [yi,yf,number_interval]=get_initConditions(e,part)
% [yi,yf,number_interval,phase]=get_initConditions(e,part)
% the boundary conditions are converted as initial conditions for the
% forwards and backwards integration of the Schrodinger equation from the
% two endpoints to the matching point.

global schrod_object;
a0 = get(schrod_object,'a0');
b0 = get(schrod_object,'b0');
a1 = get(schrod_object,'a1');
b1 = get(schrod_object,'b1');
sq1 = sqrt(a0^2+b0^2);%*10^300;
sq2 = sqrt(a1^2+b1^2);%*10^300;
yi = [-b0 / sq1;a0 / sq1];
yf = [-b1 / sq2;a1 / sq2];
if (yi(1) <= 0)
    varargout{1} = -yi;
else
    varargout{1} = yi;  
end
if (yf(1) <= 0)
    varargout{2} = -yf;
else
    varargout{2} = yf;  
end

    