function [emin,emax,nmin,nmax,err]=get_intervals(pmin,pmax,indices)
% @LPM\GET_INTERVALS
% [emin,emax,nmin,nmax,err]=get_intervals(min,max,indices)

global lpm_child
bp = get(lpm_child,'bp');
vmin = get(lpm_child,'Vmin');
vmax = get(lpm_child,'Vmax');
tol = get(lpm_child,'tol');
accepte = -2*abs(vmin);
if accepte < -100
    s=get(lpm_child,'schrod');
    V=get(s,'V');
    xmin=get(s,'min');
    xmax=get(s,'max');
    if V(xmin)<vmin || V(xmax)<vmin
       %-inf in a || -inf in b
         accepte =-1.1*abs(vmin);
         acceptn = locate_eigenvalue(accepte,bp,vmin);
         it=1;
         dif=(acceptn - pmin -1);
         while ((acceptn - pmin -1) > eps)
             accepte=0.75*accepte;
             acceptn = locate_eigenvalue(accepte,bp,vmin);
             it=it+1;
             if it>25
                err.fail = true; 
                err.msg = sprintf('The minimal eigenvalue index to be accepted is %d.',floor(acceptn));
                emin = 0;
                emax = 0;
                nmin = 0;
                nmax = 0;
                return;
             end
             if (acceptn - pmin -1)>dif
                 accepte=-2*abs(vmin);
             end
             dif=(acceptn - pmin -1);
         end
    end
end
if abs(vmin) < 2
       s=get(lpm_child,'schrod');
       V=get(s,'V');
       xmin=get(s,'min');
       vm=min(V(xmin+sum(bp.h(1:bp.imatch))),vmin);
       vm1=V(xmin+sum(bp.h(1:bp.imatch-1)));
       try
        vm2=V(xmin+sum(bp.h(1:bp.imatch+1)));
       catch
        vm2=vm1;
       end
       vm=min(vm1,vm);
       vm=min(vm2,vm);
       accepte = vm-2*max([abs(vmin-vm),abs(vmin-vm1),abs(vmin-vm2),abs(vm1-vm2)]);
end


err.fail = false;

if indices
    % the energy range [emin,emax] consistent with the input index range is
    % determined
    acceptn = locate_eigenvalue(accepte,bp,vmin);
    if ((acceptn - pmin -1) > eps)
          err.fail = true; 
          err.msg = sprintf(' The minimal eigenvalue index to be accepted is %d.',floor(acceptn));
          emin = 0;
          emax = 0;
          nmin = 0;
          nmax = 0;
          return;
    end
    e = accepte;
    scal = min(abs(e)/(pmax+1-pmin),200);
    emin = convert_n2e(e,scal,bp,vmin,vmax,pmin);
    nmin = pmin;
    emax = convert_n2e(emin,scal,bp,vmin,vmax,pmax+1); 
    if emax == 0
        emax = eps;
    end
    nmax = pmax;
else
    % produce the index of the lowest and of the highest eigenvalue in the
    % given energy interval (= nmin, nmax resp. )
    emin = pmin;
    emax = pmax;
    nmin0 = locate_eigenvalue(emin,bp,vmin); 
    nmin = floor(nmin0);
    if(abs(nmin-nmin0)<tol)
     warning('it may be safer to decrease tol')    
    end
    nmax = locate_eigenvalue(emax,bp,vmin);
    nmax = floor(nmax - 1);
end