function varargout=locate_eigenvalue(eold,part,Vmatch)
% @PPM\LOCATE_EIGENVALUE
% [pruf,phi]=locate_eigenvalue(eold,part,Vmatch)
%   
% For given e (eold) the Schrodinger equation is integrated from the
% both ends up to the matching point to produce the Prufer's 
% theta(eold)/pi (pruf).    


S = 1;
if((eold-Vmatch)> 1) 
      S = sqrt(eold-Vmatch);
end
[yi,yf] = get_initConditions;
trunca = 1;
truncb = length(part.h);
[thforw, th1]= prufer(yi(1),yi(2),yi(1),yi(2),eold,part.V0(trunca),0,S);
if thforw < 0
     thforw = pi+thforw; % thforw = theta_min 
end
[yl,theta] = propagate_solution(eold,yi,trunca,part.imatch,part,true);
thforw = thforw + theta; % thforw = thforw + delta_i;

%backward
[thbackw,th1] = prufer(yf(1),yf(2),yf(1),yf(2),eold,part.V0(truncb),0,S);
if thbackw > 0
    thbackw = thbackw-pi;
end

if truncb > part.imatch
      [yr,theta] = propagate_solution(eold,yf,part.imatch+1,truncb,part,false);
      thbackw = thbackw - theta; % thbackw = thbackw - delta_i; 
else
    yr = yf;   %in xmatch
end


varargout{1} = (thforw-thbackw)/pi;
if imag(varargout{1}) < eps
    varargout{1} = real(varargout{1});
end
if nargout == 1
    return;
end

%the data obtained at each side of xmatch are combined:
phi = yl(1)*yr(2)-yr(1)*yl(2);

varargout{2} = phi; % mismatch