function plot_partition(lpm_child)
%makes a plot of the partition and the reference potential
schrod=get(lpm_child,'schrod');
a=get(schrod,'min');
b=get(schrod,'max');
if isinf(a) || isinf(b)
    error('PLOT_PARTITION: Sorry, the partition can not be plotted for a problem with an infinite integration interval');
end
V=get(schrod,'V');
step = min(abs(b-a)/100,0.05);
while (b-a)/step >10000
     step=step*2;
end
w = a:step:b;
YY = V(w);
bp=get(lpm_child,'bp');
v0=bp.V0;
v=bp.V;
f0=v0-v(1,:).*bp.h;
f1=2*v(1,:);
x = [a a + cumsum(bp.h)];
figure;
miny=min(YY)-(max(YY)-min(YY))/10;
maxy=max(YY)+(max(YY)-min(YY))/10;
phandles= plot(x,miny*ones(1,length(x)),'bo','MarkerSize',5,'MarkerFaceColor','b');
hold on;
phandles = [phandles plot(x(bp.imatch+1),miny,'ro','MarkerSize',5,'MarkerFaceColor','r')];
phandles = [phandles plot(w,YY,'k:','LineWidth',1)];
legendStr{1} = 'meshpoints';
legendStr{2} = 'x_{match}';
legendStr{3} = 'V(x)';
legendStr{4} = 'V_{ref}';
xs=a;
ys=f0(1);  
for i=1:length(bp.h)-1
   xe=xs+bp.h(i); 
   ye=f0(i)+f1(i)*bp.h(i); 
   phandles= [phandles plot([xs xe],[ys ye],'b')];
   xs=xe;
   ys=f0(i+1);    
end
xe=xs+bp.h(end); 
ye=f0(end)+f1(end)*bp.h(end); 
phandles= [phandles plot([xs xe],[ys ye],'b')];
hold off;
warning off;
legend(phandles(1:end),legendStr,'Location','Best');
warning on;
xlabel('x');
title('The reference potential function + the meshpoints of the partition');
axis([a b  miny maxy]); 