function lp = lpm10(varargin)
%LPM10 class constructor
lp.N=4;
lp.Q=2;
lp.bp=0;
lp.rp=0;
lp.Vmin=0;
lp.Vmax=0;
lp.emin=0;
lp.emax=0;
lp.schrod=[];
%cp.ref_cpm=0;
switch nargin
 case 0
    % if no input arguments, create a default object
   parent = lpm(schrod('x',0,1),10^(-5));
   lp = class(lp,'lpm10',parent);
case 1   
    % copy-constructor
   if isa(varargin{1},'lpm10')
     lp = varargin{1};
   else
     disp('Input argument is not a lpm10 object')
   end
case 2
    var1=varargin{1};
    parent = lpm(varargin{1},varargin{2});
    lp = class(lp,'lpm10',parent);
    time = cputime;
    a=get(var1,'min');
    b=get(var1,'max');
    V=get(var1,'V');
    va=V(a);
    vb=V(b);
    vc=V((a+b)/2);
    vd=V((a+b)*0.25);
    ve=V((a+b)*0.75);
    lp.emin=min([va,vb,vc,vd,ve]); 
    lp.emax=max([va,vb,vc,vd,ve]); 
    try
     c=get(var1,'classification');
     lp.emax=max(lp.emax,c.cutoff);
    catch
    end
    [lp.bp,lp.rp,lp.Vmin,lp.Vmax] = calculate_partitions(lp);
    time = cputime -time;
otherwise
    error('lpm10: Wrong number of input arguments')
end
